#
# Compilers
#
CC = gcc
#CC = g++
LINT = splint

#
# exes
# 
EXE0 = main
TARGET = $(EXE0)

#
# Flags
#
CFLAGS = -Wall -std=c99 
# For deugging
#CFLAGS = -Wall -std=c99 -g 
# For showdeps
DFLAGS = -MM

#
# Libs + Incs
#
HEADERS=fact.h factorial.h
#HEADERS = $(wildcard *.h)
MYLIBDIR=
#MYLIBDIR=-L../lib/
lib= 
#lib= -lm 
INC=
#INC=-I../myincludes

#   
# set object files   
#   
OBJ0=$(EXE0).o

#
# Other objects
#
FACT=f1
#FACT=f2
#FACT=f3
#OOBJS = $(FACT).o factorial.o
OOBJS = $(FACT).o factorial.o 
#          patsubst(PATTERN , REPLACEMENT, INPUT)
#OOBJS = $(patsubst %.c, %.o, $(wildcard *.c))


.PHONY: all default clean one step1 step12 step123 link check test splash showdeps
.PRECIOUS: $(EXE0) $(OBJ0) $(OBJS)

## make all
all: $(EXE0) 

default: all

# make all (in one step)
one: 
	$(CC) $(CFLAGS) $(FACT).c factorial.c $(EXE0).c -o $(EXE0)

# make main
$(EXE0): $(OBJ0) $(OOBJS) $(HEADERS)
	$(CC) $(CFLAGS) $(OBJ0) $(OOBJS) $(MYLIBDIR) $(lib) -o $@

step1: 
	# preprocesa
	$(CC) $(CFLAGS) -E $(EXE0).c -o $(EXE0).i
	$(CC) $(CFLAGS) -E factorial.c -o factorial.i
	$(CC) $(CFLAGS) -E $(FACT).c -o $(FACT).i

step12:
	#preprocesa y ensambla
	$(CC) $(CFLAGS) -S $(EXE0).c
	$(CC) $(CFLAGS) -S factorial.c
	$(CC) $(CFLAGS) -S $(FACT).c

step123:
	#preprocesa, ensambla y compila
	$(CC) $(CFLAGS) -c $(EXE0).c
	$(CC) $(CFLAGS) -c factorial.c
	$(CC) $(CFLAGS) -c $(FACT).c

link: $(OBJ0) $(OOBJS)
	# gcc -Wall -std=c99 fX.c factorial.c main.c -o main
	#linkediciona
	$(CC) $(CFLAGS) $(OOBJS) $(OBJ0) -o $(EXE0)

# Old-fashioned suffix rule (cannot have any prerequisites of their own)
#.c.o: $(HEADERS)
# New-fashioned pattern rule (not posix 2 compliant)
%.o: %.c $(HEADERS) 
	$(CC) $(CFLAGS) $(INC) -c $< -o $@

showdeps:
	$(CC) $(CFLAGS) $(DFLAGS) $(wildcard *.c)

check:
	$(LINT) $(EXE0).c

test: $(EXE0)
	./$(EXE0)

clean:
	rm -f *.o $(EXE0) *.s *.i *.cpp a.out core

splash:
	rm -f *~

### EOF ###
